module filter( 
     input [11:0]p0, 
     input [11:0]p1, 
     input [11:0]p2, 
     input [11:0]p3,
     input [11:0]p5, 
     input [11:0]p6, 
     input [11:0]p7, 
     input [11:0]p8, 
     output [11:0]q);
	 
wire signed [13:0] gx,gy;    //11 bits because max value of gx and gy is 
//255*4 and last bit for sign					
wire signed [13:0] abs_gx,abs_gy;	//it is used to find the absolute value of gx and gy
wire [13:0] sum;			//the max value is 255*8. here no sign bit needed.

assign gx=((p2-p0)+((p5-p3)<<1)+(p8-p6));//sobel mask for gradient in horiz. direction
assign gy=((p6-p0)+((p7-p1)<<1)+(p8-p2));//sobel mask for gradient in vertical direction

assign abs_gx = (gx[10]? ~gx+1 : gx);	// to find the absolute value of gx.
assign abs_gy = (gy[10]? ~gy+1 : gy);	// to find the absolute value of gy.

assign sum = (abs_gx+abs_gy);				// finding the sum
assign q[7:0]  = (|sum[13:8])?8'hff : sum[7:0];	// to limit the max value to 255 
assign q[11:8] = 0;
endmodule